﻿-- Author      : Apoco
-- Create Date : 4/23/2008 2:02:15 PM

-- Author      : Apoco
-- Create Date : 3/26/2008 5:31:06 PM

local module = RBM:NewBossModule(RBM_GRUUL_KING)
module:SetZones(RBM_GRUUL)

local playerclass = select(2, UnitClass("player"))

function module:OnInitialize()
	self:RegisterToggles(RBM_HEALS, true,
						 RBM_GRUUL_KING_SPELLSHIELD, true,
						 RBM_GRUUL_KING_SHIELD, true,
						 RBM_GRUUL_KING_SUMMON, true,
						 RBM_GRUUL_KING_WHIRLWIND, true,
						 RBM_GRUUL_KING_FLURRY, true,
						 RBM_GRUUL_KING_SMASH, true
						)
	self:RegisterStartEvents("CHAT_MSG_MONSTER_YELL")
	self.SpellShieldLabel = self:CreateLabel(RBM_GRUUL_KING_SPELLSHIELD, RBM_COOLDOWN)
	self.WhirlwindLabel = self:CreateLabel(RBM_GRUUL_KING, RBM_GRUUL_KING_WHIRLWIND)
	self.NextWhirlwindLabel = self:CreateLabel(RBM_GRUUL_KING_WHIRLWIND, RBM_NEXT)
	self.FelhunterCastLabel = self:CreateLabel(RBM_GRUUL_KING_FELHUNTER)
	self.FelhunterLabel = self:CreateLabel(RBM_GRUUL_KING_FELHUNTER, RBM_COOLDOWN)
	self.PoHLabel = self:CreateLabel(RBM_GRUUL_KING_PRAYER, RBM_CASTING)
	self.HealLabel = self:CreateLabel(RBM_HEAL, RBM_CASTING)
	self.SmashLabel = self:CreateLabel(RBM_GRUUL_KING, RBM_GRUUL_KING_SMASH)
	self.WhirlwindAlert = function() self:Announce("High", RBM_GRUUL_KING_WHIRLWIND..": ~5"..RBM_SECONDS) end
end

function module:CheckStart(event, msg)
	return msg == RBM_GRUUL_KING_MSG_ENGAGE
end

function module:OnStart()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	if self:CheckToggle(RBM_GRUUL_KING_WHIRLWIND) then
		self:Sync("Whirlwind", true)
	end
	if self:CheckToggle(RBM_GRUUL_KING_SPELLSHIELD) then
		self:Sync("SpellShield", true)
	end
end

function module:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, _, _, _, _, name, _, id, spell)
	if event == "SPELL_AURA_APPLIED" then
		if id == 33147 and self:CheckToggle(RBM_GRUUL_KING_SHIELD) then
				self:Sync("Shield")
			
		elseif id == 33054 and self:CheckToggle(RBM_GRUUL_KING_SPELLSHIELD) then
			if name == RBM_GRUUL_KING_MAGE then
				self:Sync("SpellShield")
			end
		
		elseif id == 33238 and self:CheckToggle(RBM_GRUUL_KING_WHIRLWIND) then
			self:Sync("Whirlwind")
		end
	
	elseif event == "SPELL_CAST_START" then
		if id == 33131 and self:CheckToggle(RBM_GRUUL_KING_SUMMON) then
			self:Sync("Felguard")
		
		elseif (id == 33152 or id == 33144) and self:CheckToggle(RBM_HEALS) then
			self:Sync("Heal", id)
		end
	
	elseif event == "SPELL_CAST_SUCCESS" then
		if id == 39144 and self:CheckToggle(RBM_GRUUL_KING_SMASH) then
			self:Sync("Smash")
		
		elseif id == 33232 and self:CheckToggle(RBM_GRUUL_KING_FLURRY) then
			self:Sync("Flurry")
		end
	end
end

function module:OnSync(msg, name)
	if msg == "Shield" then
		self:Announce("High", RBM_GRUUL_KING_MSG_SHIELD)
	
	elseif msg == "SpellShield" then
		if not name then
			self:Announce("High", RBM_GRUUL_KING_MSG_SPELLSHIELD)
			if playerclass == "MAGE" and UnitName("target") == RBM_GRUUL_KING_MAGE then
				self:Alert("High", RBM_GRUUL_KING_MSG_SPELLSHIELD_SELF)
				self:ShakePlayerScreen()
				self:WarningFlashPlayer()
			end
		end
		self:BossBar(self.SpellShieldLabel, "Cooldown", 30, 33054)
	
	elseif msg == "Whirlwind" then
		if not name then
			self:Announce("Normal", RBM_GRUUL_KING_WHIRLWIND.."!")
			self:BossBar(self.WhirlwindLabel, "Buff", 15, 33238)
		end
		self:BossBar(self.NextWhirlwindLabel, "Cooldown", 50, 33238)
		self:ScheduleTimer(self.WhirlwindAlert, 45)
	
	elseif msg == "Felguard" then
		self:Announce("High", RBM_GRUUL_KING_MSG_FELHUNTER)
		self:BossBar(self.FelhunterCastLabel, "Cast", 3, 33131)
		self:BossBar(self.FelhunterLabel, "Cooldown", 50, 33131)
	
	elseif msg == "Heal" then
		self:Announce("High", RBM_HEAL.." "..RBM_INCOMING.."!")
		local label, dur = self.PoHLabel, 4
		if name == 33144 then
			label = self.HealLabel; dur = 1.5
		end
		self:BossBar(label, "Cast", dur, name)
	
	elseif msg == "Smash" then
		self:Announce("Low", string.upper(RBM_GRUUL_KING_SMASH))
		self:BossBar(self.SmashLabel, "Cooldown", 10, 39144)
	
	elseif msg == "Flurry" then
		self:Announce("Normal", RBM_GRUUL_KING_FLURRY.."!")
	end
end
